<?php
/**
* Web based SQLite management
* Some defines
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: defined.inc.php,v 1.52 2004/11/21 20:38:42 freddy78 Exp $ $Revision: 1.52 $
*/

$baseDir = dirname(__FILE__);

define ("INCLUDE_LIB", "./include/");

define("SQLiteDb", $baseDir."/config.db");

define("SQLiteManagerVersion", "1.0.4");

define("DEFAULT_DB_PATH", "/var/www/sqliteDb/"); 	// Default Folder for Uploaded file Database
													// for windows "C:\\Apache\\sqliteDb\\" or $baseDir
define("WITH_AUTH", false);

define("ALLOW_CHANGE_PASSWD", true);

$availableLangue = array(	1=>"french", 2=>"english", 3=>"polish",
							4=>"german", 5=>"japanese", 6=>"italian",
							7=>"croatian", 8=>"brazilian_portuguese", 9=>"dutch",
							10=>"spanish");

$dbItems = array("Table", "View", "Trigger", "Function");

define("DEBUG", false);

if(isset($_POST["Theme"])) {
	$localTheme = $_POST["Theme"];
	setcookie('SQLiteManager_currentTheme',$_POST["Theme"],1719241200,'/');
	$_COOKIE["SQLiteManager_currentTheme"] = $_POST["Theme"];
	echo "<script>parent.location='index.php';</script>";
} elseif(isset($_COOKIE["SQLiteManager_currentTheme"])) {
	$localtheme = $_COOKIE["SQLiteManager_currentTheme"];
} else {
	$localtheme = "default";
}

/**
* image to see 'ASC' order
*/
define("IMG_ASC", 	((file_exists("./theme/".$localtheme."/pics/up.gif"))? "./theme/".$localtheme."/pics/up.gif" : "./theme/default/pics/up.gif" ));/**
* image to see 'DESC' order
*/
define("IMG_DESC", 	((file_exists("./theme/".$localtheme."/pics/down.gif"))? "./theme/".$localtheme."/pics/down.gif" : "./theme/default/pics/down.gif" ));/**
* Image for paginate navigation, you can remove it.
*/
define("NAV_TOP", 	((file_exists("./theme/".$localtheme."/pics/top.gif"))? "./theme/".$localtheme."/pics/top.gif" : "./theme/default/pics/top.gif" ));/**
* Image for paginate navigation, you can remove it.
*/
define("NAV_PREC", 	((file_exists("./theme/".$localtheme."/pics/left.gif"))? "./theme/".$localtheme."/pics/left.gif" : "./theme/default/pics/left.gif" ));/**
* Image for paginate navigation, you can remove it.
*/
define("NAV_SUIV", 	((file_exists("./theme/".$localtheme."/pics/right.gif"))? "./theme/".$localtheme."/pics/right.gif" : "./theme/default/pics/right.gif" ));/**
* Image for paginate navigation, you can remove it.
*/
define("NAV_END", 	((file_exists("./theme/".$localtheme."/pics/end.gif"))? "./theme/".$localtheme."/pics/end.gif" : "./theme/default/pics/end.gif" ));/**
* Separator for navigation bar.
*/
define("NAV_SEP", 	"&nbsp;-&nbsp;");
/**
* Number of Link in the navigation bar.
*/
define("NAV_NBLINK", 10);


define("DEMO_MODE", false);

set_magic_quotes_runtime(0);
if(DEBUG) {
	error_reporting(E_ALL);
} else {
	error_reporting(E_ALL ^ E_NOTICE);
}


$SQLpunct = ".,;:=&()-+!<>";

$SQLoperator = array(
							"ABORT",
							"AFTER",
							"AND",
							"BEFORE",
							"BEGIN",
							"BETWEEN",
							"CASE",
							"CHECK",
							"COLLATE",
							"CONSTRAINT",
							"CASCADE",
							"CLUSTER",
							"CONFLICT",
							"DEFAULT",
							"DEFERRABLE",
							"DISTINCT",
							"DEFERRED",
							"DELIMITERS",
							"DESC",
							"EACH",
							"ELSE",
							"EXCEPT",
							"END",
							"FAIL",
							"FOR",
							"FOREIGN",
							"GLOB",
							"IN",
							"INTERSECT",
							"IS",
							"ISNULL",
							"IGNORE",
							"IMMEDIATE",
							"INITIALLY",
							"INSTEAD",
							"MATCH",
							"OF",
							"OFFSET",
							"RESTRICT",
							"ROW",
							"STATEMENT",
							"TEMP ALL",
							"LIKE",
							"NOT",
							"NOTNULL",
							"NULL",
							"OR",
							"PRIMARY",
							"REFERENCES",
							"THEN",
							"UNIQUE",
							"USING",
							"WHEN"
						);

$SQLKeyWordList = array(
							"AS",
							"ASC",
							"ATTACH",
							"BY",
							"COMMIT",
							"CREATE",
							"COPY",
							"CROSS",
							"DATABASE",
							"DELETE",
							"DROP",
							"DETACH",
							"EXPLAIN",
							"FROM",
							"FULL",
							"GROUP",
							"HAVING",
							"INDEX",
							"INSERT",
							"INTO",
							"INNER",
							"JOIN",
							"KEY",
							"LEFT",
							"LIMIT",
							"NATURAL",
							"OUTER",
							"PRAGMA",
							"RAISE",
							"REPLACE",
							"RIGHT",
							"ON",
							"ORDER",
							"ROLLBACK",
							"SELECT",
							"SET",
							"TABLE",
							"UNION",
							"UPDATE",
							"VALUES",
							"VACUUM",
							"VIEW",
							"WHERE",
							"TEMPORARY",
							"TRANSACTION",
							"TRIGGER"
						);

$SQLfunction	= array(
							"LENGTH",
							"LOWER",
							"UPPER",
							"SUBSTR",
							"SOUNDEX",
							"MD5",
							"NOW",
							"LAST_INSERT_ROWID",
							"RANDOM",
							"COUNT",
							"ABS",
							"AVG",
							"SUM",
							"MIN",
							"MAX",
							"ROUND"
						);
$SQLiteType		= array(
							""				=>	"",
							"VARCHAR"		=>	"",
							"TINYINT"		=>	"0",
							"INTEGER"		=>	"0",
							"INT"			=>	"0",
							"TEXT"			=>	"",
							"DATE"			=>	"0000-00-00",
							"SMALLINT"		=>	"0",
							"MEDIUMINT"		=>	"0",
							"BIGINT"		=>	"0",
							"FLOAT"			=>	"0.0",
							"DOUBLE"		=>	"0",
							"DECIMAL"		=>	"0.0",
							"DATETIME"		=>	"0000-00-00 00:00",
							"TIMESTAMP"		=>	"0",
							"TIME"			=>	"00:00",
							"YEAR"			=>	"0",
							"CHAR"			=>	"",
							"TINYBLOB"		=>	"",
							"TINYTEXT"		=>	"",
							"BLOB"			=>	"",
							"MEDIUMBLOB"	=>	"",
							"MEDIUMTEXT"	=>	"",
							"LONGBLOB"		=>	"",
							"LONGTEXT"		=>	"",
							"CLOB"			=>	"",
							"BOOLEAN"		=>	"",
						);

$SQLselect = array(		
                            "<",
                            "<=",
                            ">",
                            ">=",
                            "=",
                            "!=",
                            "LIKE",
                            "NOT LIKE",
                            "GLOB",
                            "NOT GLOB",
                            "ISNULL",
                            "NOTNULL"
						);						

?>
